#include "_gen/svc.h"

#include <telepathy-glib/dbus.h>
#include "_gen/signals-marshal.h"

static const DBusGObjectInfo _ring_svc_channel_future_object_info;

struct _RingSvcChannelFutureClass {
    GTypeInterface parent_class;
};

static void ring_svc_channel_future_base_init (gpointer klass);

GType
ring_svc_channel_future_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (RingSvcChannelFutureClass),
        ring_svc_channel_future_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "RingSvcChannelFuture", &info, 0);
    }

  return type;
}

static inline void
ring_svc_channel_future_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[2] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "o", 0, NULL, NULL }, /* Bundle */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  dbus_g_object_type_install_info (ring_svc_channel_future_get_type (),
      &_ring_svc_channel_future_object_info);

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Channel.FUTURE");
  properties[0].name = g_quark_from_static_string ("Bundle");
  properties[0].type = DBUS_TYPE_G_OBJECT_PATH;
  tp_svc_interface_set_dbus_properties_info (RING_TYPE_SVC_CHANNEL_FUTURE, &interface);

}
static void
ring_svc_channel_future_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      ring_svc_channel_future_base_init_once (klass);
    }
}
static const DBusGMethodInfo _ring_svc_channel_future_methods[] = {
  { NULL, NULL, 0 }
};

static const DBusGObjectInfo _ring_svc_channel_future_object_info = {
  0,
  _ring_svc_channel_future_methods,
  0,
"\0",
"\0\0",
"\0\0",
};

static const DBusGObjectInfo _ring_svc_channel_interface_mergeable_conference_object_info;

struct _RingSvcChannelInterfaceMergeableConferenceClass {
    GTypeInterface parent_class;
    ring_svc_channel_interface_mergeable_conference_merge_impl merge_cb;
};

static void ring_svc_channel_interface_mergeable_conference_base_init (gpointer klass);

GType
ring_svc_channel_interface_mergeable_conference_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (RingSvcChannelInterfaceMergeableConferenceClass),
        ring_svc_channel_interface_mergeable_conference_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "RingSvcChannelInterfaceMergeableConference", &info, 0);
    }

  return type;
}

static void
ring_svc_channel_interface_mergeable_conference_merge (RingSvcChannelInterfaceMergeableConference *self,
    const gchar *in_Channel,
    DBusGMethodInvocation *context)
{
  ring_svc_channel_interface_mergeable_conference_merge_impl impl = (RING_SVC_CHANNEL_INTERFACE_MERGEABLE_CONFERENCE_GET_CLASS (self)->merge_cb);

  if (impl != NULL)
    {
      (impl) (self,
        in_Channel,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

void
ring_svc_channel_interface_mergeable_conference_implement_merge (RingSvcChannelInterfaceMergeableConferenceClass *klass, ring_svc_channel_interface_mergeable_conference_merge_impl impl)
{
  klass->merge_cb = impl;
}

static inline void
ring_svc_channel_interface_mergeable_conference_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  dbus_g_object_type_install_info (ring_svc_channel_interface_mergeable_conference_get_type (),
      &_ring_svc_channel_interface_mergeable_conference_object_info);

}
static void
ring_svc_channel_interface_mergeable_conference_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      ring_svc_channel_interface_mergeable_conference_base_init_once (klass);
    }
}
static const DBusGMethodInfo _ring_svc_channel_interface_mergeable_conference_methods[] = {
  { (GCallback) ring_svc_channel_interface_mergeable_conference_merge, ring_tp_marshal_VOID__BOXED_POINTER, 0 },
};

static const DBusGObjectInfo _ring_svc_channel_interface_mergeable_conference_object_info = {
  0,
  _ring_svc_channel_interface_mergeable_conference_methods,
  1,
"org.freedesktop.Telepathy.Channel.Interface.MergeableConference.DRAFT\0Merge\0A\0Channel\0I\0o\0\0\0",
"\0\0",
"\0\0",
};

static const DBusGObjectInfo _ring_svc_channel_interface_splittable_object_info;

struct _RingSvcChannelInterfaceSplittableClass {
    GTypeInterface parent_class;
    ring_svc_channel_interface_splittable_split_impl split_cb;
};

static void ring_svc_channel_interface_splittable_base_init (gpointer klass);

GType
ring_svc_channel_interface_splittable_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (RingSvcChannelInterfaceSplittableClass),
        ring_svc_channel_interface_splittable_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "RingSvcChannelInterfaceSplittable", &info, 0);
    }

  return type;
}

static void
ring_svc_channel_interface_splittable_split (RingSvcChannelInterfaceSplittable *self,
    DBusGMethodInvocation *context)
{
  ring_svc_channel_interface_splittable_split_impl impl = (RING_SVC_CHANNEL_INTERFACE_SPLITTABLE_GET_CLASS (self)->split_cb);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

void
ring_svc_channel_interface_splittable_implement_split (RingSvcChannelInterfaceSplittableClass *klass, ring_svc_channel_interface_splittable_split_impl impl)
{
  klass->split_cb = impl;
}

static inline void
ring_svc_channel_interface_splittable_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  dbus_g_object_type_install_info (ring_svc_channel_interface_splittable_get_type (),
      &_ring_svc_channel_interface_splittable_object_info);

}
static void
ring_svc_channel_interface_splittable_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      ring_svc_channel_interface_splittable_base_init_once (klass);
    }
}
static const DBusGMethodInfo _ring_svc_channel_interface_splittable_methods[] = {
  { (GCallback) ring_svc_channel_interface_splittable_split, g_cclosure_marshal_VOID__POINTER, 0 },
};

static const DBusGObjectInfo _ring_svc_channel_interface_splittable_object_info = {
  0,
  _ring_svc_channel_interface_splittable_methods,
  1,
"org.freedesktop.Telepathy.Channel.Interface.Splittable.DRAFT\0Split\0A\0\0\0",
"\0\0",
"\0\0",
};


